Subject: Re: [Tools-discuss] Rfcmarkup-1.86 feedback

From: Henrik Levkowetz <[email-masked]>
Date: Wed, 03 Mar 2010 13:48:58 +0100

Hi David,

On 2010-02-11 20:21 David H Gunnells said:
> Hello,
> 
> I noticed a few problems with the output of rfcmarkup 1.85a, fixes
> for which I do not see mentioned in the changelog for 1.86
> (http://tools.ietf.org/tools/rfcmarkup/changeloghttp://tools.ietf.org/tools/rfcmarkup/changelog).
> 
> 1)      When a section is specified in reference to an RFC external
> to the RFC currently being viewed, rfcmarkup links to an anchor in
> the current document instead of the external RFC referenced on the
> same line.
> 
> For example, go to http://tools.ietf.org/html/rfc4021#section-2.1.1.
> Under "Specification document(s):" you see:
> 
> RFC 2822<http://tools.ietf.org/html/rfc2822>
> [18<http://tools.ietf.org/html/rfc4021#ref-18>] (section
> 3.6.1<http://tools.ietf.org/html/rfc4021#section-3.6.1>)
> 
> As you can see, the RFC 2822 link is correct as is the link for
> reference 18. The section 3.6.1 link should go to
> http://tools.ietf.org/html/rfc2822#section-3.6.1 instead of
> http://tools.ietf.org/html/rfc4021#section-3.6.1.

Yes.  This is one of many similar special cases, and I acknowledge the
flaw, while deciding to not tackle this at this time.

> I'm guessing that rfcmarkup could look for an RFC x preceding any
> "section y" (only on the same line & skipping any references) and
> then append the section anchor link to said RFC x link and that would
> be a good start.
> 
> I noticed a few sections in the rfcmarkup code that (seem to?)
> attempt to address this situation, but I am not well versed in python
> or regular expressions enough to be able to decipher or help much.
> Looking at the sections # contents link markup: section links, #
> section number tag markup, and # section number link markup, I wonder
> if there is a conflict somewhere that breaks this.

I think it's the intervening internal reference link which prevents the
correct linkage in this case.

> 2)      When two or more sections are referenced in the same
> sentence, links are not generated, assumedly due to the "s" appended
> to section.
> 
> See the last sentence in the third paragraph in section 3.6 of RFC
> 2822: http://tools.ietf.org/html/rfc2822#section-3.6

Right.  Fixed in the recently released v1.87

> 3)      When a section reference is split across two different lines,
> a link is not generated.

Hmm.  I'll have to look some more at this case -- the split across lines
should not matter, but...

> See the last paragraph in section 3.6.2 of RFC 2822,
> http://tools.ietf.org/html/rfc2822#section-3.6.2, where it says "See
> also section 3.6.3 for more...".

Thank you for writing and for pointing out these flaws; I was aware of
some of them, but at this stage of the tools development it's mostly
when people write in to point out specific flaws that I get the impetus
to fix particular issues.

Best regards,

	Henrik